// DaneListyJed
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

// ZestawImion - przechowuje imiona
class ZestawImion
{
  public:
    ZestawImion(string& refName)
        : sImie(refName), pNastepny(nullptr) {}
    // dodaj siebie do początku listy
    void dodaj()
    {
        this->pNastepny = pGlowa;
        pGlowa = this;
    }
    // metody dostępu
    static ZestawImion* first() { return pGlowa; }
           ZestawImion* next() { return pNastepny; }
          const string& imie() { return sImie; }
  protected:
    string sImie;
    // link do pierwszego i następnego elementu listy
    static ZestawImion* pGlowa;
    ZestawImion* pNastepny;
};

// alokuj miejsce na wskaźnik do głowy
ZestawImion* ZestawImion::pGlowa = nullptr;

// pobierzDane - wczytaj imię
ZestawImion* pobierzDane()
{
    // wczytaj imię
    string imie;
    cout << "Wprowadź imię:";
    cin  >> imie;

    // Jeśli imię to 'q'...
    if (imie == "q")
    {
        // ...zwróć null
        return 0;
    }

    // zwróć obiekt z imieniem
    return new ZestawImion(imie);
}

int main(int nNumberofArgs, char* pszArgs[])
{
    cout << "Wczytaj imiona studentów\n"
         << "Wprowadź 'q' aby wyjść"
         << endl;

    // utwórz obiekt ZestawImion
    ZestawImion* pNDS;
    while (pNDS = pobierzDane())
    {
        // dodaj pobrane dane do zestawu imion
        pNDS->dodaj();
    }

    // wyświetl imiona - zatrzymaj iterację po osiągnięciu wartości pustej
    cout << "\Wpisy:" << endl;
    for(ZestawImion *pIter = ZestawImion::first();
        pIter;
        pIter = pIter->next())
    {
        cout << pIter->imie() << endl;
   }

    // aby pozwolić użytkownikowi zobaczyć wynik programu
    // przed zakończeniem programu, poczekaj, aż użytkownik będzie gotowy
    cout << "Naciśnij Enter, aby kontynuować..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
