// NiePrzepełnianieBufora2 — w tym programie zapobiegamy
// hakowaniu za pomocą bufora o zmiennej wielkości
#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
using namespace std;
// wezString — odczytaj ciąg znaków wprowadzonych
// przez użytkownika i zwróć go do miejsca wywołania
char* wezString(istream& cin)
{
    // utwórz bufor o zmiennej wielkości z początkowym
    // rozmiarem 64 znaków; jednak ten bufor może zostać
    // zwiększony, jeśli w pliku wejściowym będzie
    // więcej niż 64 znaki
    vector<char> bufor;
    bufor.reserve(64);
    // teraz załaduj ciąg znaków z pliku
    for(;;)
    {
        // przeczytaj następny znak
        char c = cin.get();
        // wyjdź z pętli, jeśli przeczytasz NULL lub EOF
        if ((c == 0) || cin.eof())
        {
            break;
        }
        // dodaj znak do bufora i jeśli to konieczne
        // zwiększ bufor, aby go zmieścić
        bufor.push_back(c);
    }
    // upewnij się, że bufor zakończony znakiem null
    bufor.push_back('\0');
    // zwróć kopię ciągu znaków do miejsca wywołania
    char* pB = new char[bufor.size()];
    if (pB != nullptr)
    {
        strcpy(pB, bufor.data());
    }
    return pB;
}
int main(int nLiczbaArgumentow, char* pArgv[])
{
    // pobierz nazwę pliku do odczytania
    cout << "Ten program odczytuje dane wejściowe z pliku wejściowego\n"
            "Wprowadź nazwę pliku:";
    string sName;
    cin >> sName;
    // otwórz plik
    ifstream c(sName.c_str());
    if (!c)
    {
        cout << "\nBłąd otwarcia pliku wejściowego" << endl;
        exit(-1);
    }
    // wczytaj zawartość pliku do obiektu
    char* pB = wezString(c);
    // wyświetl to, co mamy
    cout << "\nPomyślnie wczytaliśmy:\n" << pB << endl;
    cout << "Naciśnij Enter, aby kontynuować..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    printf("Gotowe!");
    exit(0);
    return 0;
}
